<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	page = The page to absolutise
 *	path = Prefix to append to "page" unless it is absolute already (default the current path).
 *	Function: To return
 *		{arg%page} if it is null or starts with /
 *		{arg%path}/{arg%page} otherwise
 ************************************************************/

function absolutise page="" path={sys%urlpart:path}
{
	var result%function = {arg%page};
	if ('{#arg%page:}' > 0 && '{result%function|foundre:^/}' == 0)
		var result%function = {arg%path}/{result%function};
}

/************************************************************
 *	page = The page to link to on each link on the navigation bar (default the current page)
 *	path = Prefix to append to the page link if it is relative (the NextPage or PreviousPage).
 *	Function: To return via result%function an array containing caption=>URL for a series of
 *		navigation link (including caption << and >> for previous and next if applicable).
 *		The series is based on the NextPage and PreviousPage settings in the text scheme file.
 ************************************************************/

function pagenav page={sys%urlpart:pathpage} path=
{
	absolutise page={arg%page};
	var thispage = {result%absolutise};
	var abspath = {thispage} conv="replacere:/[^/]*$";

	var nextrange = (array);
	absolutise page={scheme%text{thispage}&NextPage} path={abspath};
	var nextpage = {result%absolutise};
	var thisnext = {nextpage};
	while ('{nextpage}' != '')
	{
		var nextrange = (var)nextrange conv=push:{nextpage};
		absolutise page={scheme%text{nextpage}&NextPage} path={abspath};
		var nextpage = {result%absolutise};
	}

	var prevrange = (array);
	absolutise page={scheme%text{thispage}&PreviousPage} path={abspath};
	var prevpage = {result%absolutise};
	var thisprev = {prevpage};
	while ('{prevpage}' != '')
	{
		var prevrange = (var)prevrange conv=push:{prevpage};
		absolutise page={scheme%text{prevpage}&PreviousPage} path={abspath};
		var prevpage = {result%absolutise};
	}

	if ('{#prevrange}' == 0 && '{#nextrange}' == 0)
	{
		var result%function = (array);
		return;
	}

	var result%function = "(array)0=>";  // Position stuffing

	var prevrange = (var)prevrange conv=reverse;
	foreach (prevrange)
		var result%function = (var)result%function conv="push:{arg%path}{foreach}";

	var result%function = (var)result%function conv="push:{arg%path}{thispage}";

	foreach (nextrange)
		var result%function = (var)result%function conv="push:{arg%path}{foreach}";

	if ('{#prevrange}' > 0)
		var result%function = "(array)<<=>{arg%path}{thisprev}" conv="merge:(var)result%function";

	if ('{#nextrange}' > 0)
		var result%function = (var)result%function conv="merge:(array)>>=>{arg%path}{thisnext}";

	clear result%function:0;
}
</script>
