<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_parse: Parse the XML string and store the XML object
 *		in this%xml_{node} and the attributes in classes
 *		this%attr_value_{node} (where {node} is the nodes of the XML object.
 *
 *	Note: Please remember to do this%reset after parsing.
 *
 *	arg%xmldoc - the XML Document to parse
 ************************************************************/

function xml_parse
{
	this%xml_clear;
	xmlparse "{arg%xmldoc}" xml="xmlClass" attr="attrClass";
	if ({status%xmlparse}) return status="{status%xmlparse}" message="{message%xmlparse}";

	// Work out the parent array for tree_reset
	var parentLevelArr = "(array)";
	var parentPointerArr = "(array)";
	var allnodes = "(array)";

	if (!{this%turbo}) {
		foreach ((array){class%list:xmlClass} as node) {
			// First, "declass" xmlClass
			var this%xml_{node} = "(var)xmlClass%{node}";
			var level = "{this%xml_{node}:level}";
			clear this%xml_{node}:level;  // Don't need it after this
	
			// Parent
			var type = "{this%xml_{node}:type}";
			if ('{type}' == 'open' || '{type}' == 'complete')
				var parentLevelArr:{level} = "{node}";
			var parentNode = "{parentLevelArr:{level|dec}}";
			var parentPointerArr:{node} = "{parentNode}";
	
			var allnodes conv="push:{node}";
		}
	
		// "declass" attrClass
		foreach ((array){class%list:attrClass}) {
			var this%attr_value_{foreach} = "(var)attrClass%{foreach}";
		}
	} else {
</script>
<?php
		$allnodes =& BEE_var("allnodes");
		$arr = BEE_get("(array){class%list:xmlClass}");
		foreach ($arr as $node) {
			BEE_set("this%xml_$node", BEE_get("(var)xmlClass%$node"));
			BEE_set("level", BEE_get("{this%xml_$node:level}"));
			BEE_clear("this%xml_$node:level");  // Don't need it after this
	
			// Parent
			$type =& BEE_var("type");
			$type = BEE_get("{this%xml_$node:type}");
			if ($type == 'open' || $type == 'complete')
				BEE_set("parentLevelArr:{level}", $node);
			BEE_set("parentNode", BEE_get("{parentLevelArr:{level|dec}}"));
			BEE_set("parentPointerArr:$node", BEE_get("{parentNode}"));

			array_push($allnodes, $node);
		}
	
		// "declass" attrClass
		$arr = BEE_get("(array){class%list:attrClass}");
		foreach ($arr as $foreach) {
			BEE_set("this%attr_value_$foreach", BEE_get("(var)attrClass%$foreach"));
		}
?>
<script language="bee">
	}
	
	this%tree_reset parent="(var)parentPointerArr";
}


/************************************************************
 *	xml_reset: Reset the XML object.  Needs to be called after
 *		the XML document has changed.
 *
 *	arg%namespace - the default namespace if there isn't one in the xmldoc
 ************************************************************/

function xml_reset
{
	if ({#arg:namespace}) var this%namespace = "{arg%namespace}";
	// The namespace argument below is an array: ''=>{this%namespace} for the default namespace.
	if ({this%root|isset}) this%xml_setstruct node="{this%root}" namespace="{this%namespace}";
}


/************************************************************
 *	xml_clear: Clear the XML object to remove all structural constructs
 *
 *	//arg%node - clear the subtree under {arg%node} (optional)
 ************************************************************/

function xml_clear
{
	foreach ((array){class%list:this})
		if ({foreach|foundre:^xml_} || {foreach|foundre:^attr_}) clear this%{foreach};
/*
	// Clear xml and attr variables
	if ({arg%function:node|isset}) var param%xml_getnodelist:node = "{arg%node}";
	this%xml_getnodelist;
	foreach (result%xml_getnodelist)
		if ({foreach|foundre:^xml_} || {foreach|foundre:^attr_}) clear this%{foreach};
 */
}
</script>
