<?php include("bee/compiler.php"); return; ?>
<script language="bee">
/************************************************************
 *	dbobj_menu: Display the record set as a menu
 *
 *	arg%self = the name of the field holding the "Self" value
 *	arg%root = the root node name
 *	arg%active = the active node name
 *	arg%show = the minimum "activeness" to show
 *	arg%indent = the indentation "tab"
 *	arg%format:node		the format of the node
 *	arg%format:current	the format of the current node (default arg%format:node)
 *	arg%format:open		the format of opened nodes (default arg%format:current)
 *	arg%format:close	the format of closed nodes (default arg%format:open)
 *	arg%format:off		the format of off nodes (default arg%format:close)
 *	arg%format:currentparent	the format of the current node if it's a parent (default arg%format:current)
 *	arg%format:openparent		the format of opened parent nodes (default arg%format:open)
 *	arg%format:closeparent		the format of closed parent nodes (default arg%format:close)
 *	arg%format:offparent		the format of off parent nodes (default arg%format:off)
 *	arg%prev = the parent variable name to receive the record preceeding the current one
 *	arg%next = the parent variable name to receive the record following the current one
 ************************************************************/

function dbobj_menu show=1 indent="&nbsp;&nbsp;"
{   
	var format = (var)arg%format;
	if (!{format:current|isset}) var format:current = "{format:node}";
	if (!{format:open|isset}) var format:open = "{format:current}";
	if (!{format:close|isset}) var format:close = "{format:open}";
	if (!{format:off|isset}) var format:off = "{format:close}";
	if (!{format:currentparent|isset}) var format:currentparent = "{format:current}";
	if (!{format:openparent|isset}) var format:openparent = "{format:open}";
	if (!{format:closeparent|isset}) var format:closeparent = "{format:close}";
	if (!{format:offparent|isset}) var format:offparent = "{format:off}";
	
	var lead = "(array)
		30=>{format:current},
		20=>{format:open},
		10=>{format:close},
		00=>{format:off},
		31=>{format:currentparent},
		21=>{format:openparent},
		11=>{format:closeparent},
		01=>{format:offparent}";
	
	dbtree this self="{arg%self}" root="{arg%root}" active="{arg%active}";
	var minact = "{arg%show}";
	if ({#minact:} == 0) var minact = 1;

	var gotCurrent = 0;
	foreach ((dbtree)this as rec)
	{
//display "rec:{rec|list}<br>\n";
//result%dumpobj;
		if ({result%this:activeness} >= {minact})
		{   
			var dispstr = "{lead:{result%this:activeness}{result%this:isparent}}";
			var dispstr = "{dispstr}" conv="replace:@@INDENT,{arg%indent|repeat:{result%this:level}}";
			var dispstr = "{dispstr}" conv="replace:@@ACTIVENESS,{result%this:activeness}";
			var dispstr = "{dispstr}" conv="replace:@@ISPARENT,{result%this:isparent}";
			var dispstr = "{dispstr}" conv="replace:@@LEVEL,{result%this:level}";
			foreach (rec) var dispstr = "{dispstr}" conv="replace:@{foreach:key},{foreach}";
			
			display "{dispstr}";
		}
	
		switch ({gotCurrent})
		{
		case 0:
			if ({result%this:activeness} == 3) var gotCurrent = 1;
			else var prev = "(var)rec";
			break;
		case 1:
			var next = "(var)rec";
			var gotCurrent = 2;  // The work to obtain prev and next is finished
			break;
		}
	}
	
	if ({arg%prev|isset} && {prev|isset})
	{
		parent "{arg%prev}";
		var "{arg%prev}" = "(var)prev";
	}
	
	if ({arg%next|isset} && {next|isset})
	{
		parent "{arg%next}";
		var "{arg%next}" = "(var)next";
	}
}
</script>
