<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	Node access
 ************************************************************/

function tree_current
{
	var result%function = "{this%current}";
}

function tree_parent count=1
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	var result%function = "{node}";
	var result%function:count = 0;

	while maxiter="{count}" ({this%parent:{result%function}|isset}) {
		var result%function = "{this%parent:{result%function}}";
		var result%function:count conv="inc";
	}

	if ({#count:} && {result%function:count} < {count}) {
		var status%function = 1;
		var message%function = "Up beyond the root";
	}

/*
	this%tree_traverse pointer="parent" node="{arg%node}" count="{arg%count}";
	var result%function = "(var)result%tree_traverse";
	return status="{status%tree_traverse}" message="{message%tree_traverse}";
 */
}

function tree_child count=1
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	var result%function = "{node}";
	var result%function:count = 0;

	while maxiter="{count}" ({this%child_{result%function}|isset}) {
		var result%function = "{this%child_{result%function}:#0}";
		var result%function:count conv="inc";
	}

	if ({#count:} && {result%function:count} < {count}) {
		var status%function = 1;
		var message%function = "Down beyond a leaf";
	}

/*
	this%tree_traverse pointer="child" node="{arg%node}" count="{arg%count}";
	var result%function = "(var)result%tree_traverse";
	return status="{status%tree_traverse}" message="{message%tree_traverse}";
 */
}

function tree_elder count=1
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_siblings node="{node}";  // Must have at least one
	var pos = "{result%tree_siblings|valuepos:{node}}";
	var newpos = 0;  // First node
	if ({#count:}) {
		var newpos = "{pos|dec:{count}}";
		if ({newpos} < 0) var newpos = 0;
	}

	var result%function = "{result%tree_siblings:{newpos}";
	var result%function:count = "(expr){pos} - {newpos}";

	if ({#count:} && {result%function:count} < {count}) {
		var status%function = 1;
		var message%function = "Go back beyond the eldest";
	}

/*
	this%tree_traverse pointer="elder" node="{arg%node}" count="{arg%count}";
	var result%function = "(var)result%tree_traverse";
	return status="{status%tree_traverse}" message="{message%tree_traverse}";
 */
}

function tree_younger count=1
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_siblings node="{node}";  // Must have at least one
	var pos = "{result%tree_siblings|valuepos:{node}}";
	var lastpos = "{#result%tree_siblings}" conv="dec";  // Last node
	var newpos = "{lastpos}";
	if ({#count:}) {
		var newpos = "{pos|inc:{count}}";
		if ({newpos} > {lastpos}) var newpos = "{lastpos}";
	}

	var result%function = "{result%tree_siblings:{newpos}";
	var result%function:count = "(expr){newpos} - {pos}";

	if ({#count:} && {result%function:count} < {count}) {
		var status%function = 1;
		var message%function = "Forward beyond the youngest";
	}

/*
	this%tree_traverse pointer="younger" node="{arg%node}" count="{arg%count}";
	var result%function = "(var)result%tree_traverse";
	return status="{status%tree_traverse}" message="{message%tree_traverse}";
 */
}

function tree_root
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_parent node="{node}" count="";
	var result%function = "(var)result%tree_parent";
	return status="{status%tree_parent}" message="{message%tree_parent}";
}

function tree_leaf
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_child node="{node}" count="";
	var result%function = "(var)result%tree_child";
	return status="{status%tree_child}" message="{message%tree_child}";
}

function tree_eldest
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_elder node="{node}" count="";
	var result%function = "(var)result%tree_elder";
	return status="{status%tree_elder}" message="{message%tree_elder}";
}

function tree_youngest
{
	var node = "{arg%node}";
	// Allow blank node
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	this%tree_younger node="{node}" count="";
	var result%function = "(var)result%tree_younger";
	return status="{status%tree_younger}" message="{message%tree_younger}";
}
</script>
