<?php include("bee/compiler.php"); return; ?>
<script language="bee">
include "common/tree.bs";

/************************************************************
 *	xml: XML Object
 *
 *	The constructor creates an empty XML document, and encapsulate
 *	it with XML operations.  If arg%xmldoc is provided, it will be parsed.
 *
 *	xml is a "tree"
 *
 *	arg%xmldoc - the XML string to parse
 *	arg%namespace - the default namespace if there isn't one in the xmldoc
 *
 *	Object variables:
 *	this%xml_{node} - the node {node} of the XML document
 *	this%attr_value_{node}:{attr} - the value of attribute {attr} of node {node}
 *	this%attr_namespace_{node}:{attr} - the namespace of attribute {attr} of node {node}
 *	this%attr_localpart_{node}:{attr} - the localpart of attribute {attr} of node {node}
 *	this%attr_prefix_{node}:{attr} - the prefix of attribute {attr} of node {node}
 *	this%namespace - the default namespace
 ************************************************************/

function xml
{
	this%tree turbo="{arg%turbo}";
	var this%turbo = "{arg%turbo|meanstrue}";

	// xml_init
	var this%function:parse = "xml_parse";
	var this%function:reset = "xml_reset";
	var this%function:clear = "xml_clear";

	// xml_stru
	// PRIVATE var this%function:setstruct = "xml_setstruct";
	// PRIVATE var this%function:xltns = "xml_xltns";

	// xml_gets
	var this%function:getnode = "xml_getnode";
	var this%function:getnodelist = "xml_getnodelist";
	var this%function:getattr = "xml_getattr";
	var this%function:getattrlist = "xml_getattrlist";
	
	// xml_sets
	var this%function:setnode = "xml_setnode";

	// xml_mult
	var this%function:attributes = "xml_attributes";
	var this%function:nodes = "xml_nodes";

	// xml_find
	var this%function:searchattr = "xml_searchattr";
	var this%function:searchnode = "xml_searchnode";

	// xml_util
	var this%function:filter = "xml_filter";
	// PRIVATE var this%function:filtersubtree = "xml_filtersubtree";

	// xml_xdoc
	var this%function:xmldoc = "xml_xmldoc";
	
	// xml_disp
	var this%function:dump = "xml_dump";

	// Data
	var this%namespace = "{arg%namespace}";

	if ({#arg%xmldoc:}) {
		this%xml_parse xmldoc="{arg%xmldoc}";
		if ({status%xml_parse}) return status="{status%xml_parse}" message="{message%xml_parse}";
	}

	this%xml_reset;
}

include "common/xml_init.bs";
include "common/xml_stru.bs";
include "common/xml_gets.bs";
include "common/xml_sets.bs";
include "common/xml_mult.bs";
include "common/xml_find.bs";
include "common/xml_util.bs";
include "common/xml_xdoc.bs";
include "common/xml_disp.bs";
</script>