<?php include("bee/compiler.php"); return; ?>
<script language="bee">
// This script needs to be processed after the Portal object is created but before the menu is generated.
// All display should be in MenuEditDisplay or, if error, MenuEditError

MenuName = "{{PortalObjectName}%MenuName}";
MenuTable = "{{PortalObjectName}%MenuTable}";

output bufferbegin;

// theGreatEscape
function TGE
{
	result%function = "{arg%value}";
	result%function = "{result%function|escape:single}";
	result%function = "{result%function|replace:\,,\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\,}";
//display "result%function=[{result%function}]<br>\n";
}

function deleteMenuItem
{
//display "deleteMenuItem {arg%function|list:(@key='@value') ()}<br>\n";
	global MenuName;
	global {MenuName}%;
	global MenuTable;

	if ({#arg%menuitem:} == 0) return;
	clear topicList;
	{MenuName}%query "select Topic from {MenuTable} where Parent = '{arg%menuitem|TGE}'";
	foreach ((db){MenuName}) {
		if ({#foreach} == 0) break;
		var topicList conv="push:{foreach:Topic}";
	}
	foreach (topicList) deleteMenuItem menuitem="{foreach}";
	{MenuName}%query "delete from {MenuTable} where Topic = '{arg%menuitem|TGE}'";
//display "delete from {MenuTable} where Topic = '{arg%menuitem|TGE}'<br>\n";
	if ({{MenuName}%status}) display '<center><span class="error">{{MenuName}%message} when deleting (Error {{MenuName}%status})</span></center>\n';
}

function insertMenuItem
{
//display "insertMenuItem arg%function=[{arg%function|list}]<br>\n";
	global MenuName;
	global {MenuName}%;
	global MenuTable;

//display "arg%Description=[{arg%Description}]<br>\n";
//display "arg%Description|TGE=[{arg%Description|TGE}]<br>\n";
	{MenuName}%query "insert into {MenuTable} ( Parent, Topic, Name, Description, Page, Param, AccessLevel ) values ( '{arg%Parent|TGE}', '{arg%Topic|TGE}', '{arg%Name|TGE}', '{arg%Description|TGE}', '{arg%Page|TGE}', '{arg%Param|TGE}', '{arg%AccessLevel|TGE}' )";
//display "insert into {MenuTable} ( Parent, Address, Name, Description, Page, AccessLevel, Param ) values ( '{arg%Parent|TGE}', '{arg%Address|TGE}', '{arg%Name|TGE}', '{arg%Description|TGE}', '{arg%Page|TGE}', '{arg%Param|TGE}', '{arg%AccessLevel|TGE}' )<br>\n";
	if ({{MenuName}%status}) display '<center><span class="error">{{MenuName}%message} when inserting (Error {{MenuName}%status})</span></center>\n';
}

MenuEditError = "";

access (lt editor) {
	MenuEditError = '<center><span class="error">Please login first</span></center>\n';
}

if ({#MenuEditError:} == 0) {
	if ({#{PortalObjectName}%function:new} == 0) {
		MenuEditError = '<center><span class="error">Portal Object "{PortalObjectName}" does not exist</span></center>\n';
	}
}

if ({#MenuEditError:} == 0) {
	if ({#{MenuName}%function:new} == 0) {
		MenuEditError = '<center><span class="error">Menu Object "{MenuName}" does not exist</span></center>\n';
	}
}

if ({#MenuEditError:} == 0) {
	MenuType = "{{PortalObjectName}%MenuType}";
	
	//MenuModel = "{{PortalObjectName}%MenuModel}";

	//textDir = "{scheme%textDir}";
	//if ({#textDir:} == 0) textDir = "{sys%croft:textdir}";
	textDir = "{sys%croft:textdir}";
	
	curTopic = "{sys%form:oldTopic}";
	Submit = "{sys%form:Submit}";
	dirty = 0;
	switch ('{Submit}') {
	// TopicForm
	case 'Save the changes':
		{MenuName}%query "update {MenuTable} set Topic = '{sys%form:Topic|TGE}', Name = '{sys%form:Name|TGE}', Description = '{sys%form:Description|TGE}', Page = '{sys%form:Page|TGE}', Param = '{sys%form:Param|TGE}', AccessLevel = '{sys%form:AccessLevel|TGE}' where Topic = '{curTopic|TGE}'";
//display "update {MenuTable} set Topic = '{sys%form:Topic|TGE}', Name = '{sys%form:Name|TGE}', Description = '{sys%form:Description|TGE}', Page = '{sys%form:Page|TGE}', Param = '{sys%form:Param|TGE}', AccessLevel = '{sys%form:AccessLevel|TGE}' where Topic = '{curTopic|TGE}'<br>\n";
		if ({{MenuName}%status}) {
			display '<center><span class="error">{{MenuName}%message} when updating (Error {{MenuName}%status})</span></center>\n';
			break;
		}
		if ('{sys%form:Topic}' != '{curTopic}') {
			{MenuName}%query "update {MenuTable} set Parent = '{sys%form:Topic|TGE}' where Parent = '{curTopic|TGE}'";
//display "update {MenuTable} set Parent = '{sys%form:Address|TGE}' where Parent = '{curTopic|TGE}'<br>\n";
		}
		if ({{MenuName}%status}) display '<center><span class="error">{{MenuName}%message} when updating items within {sys%form:Name} (Error {{MenuName}%status})</span></center>\n';
		curTopic = "{sys%form:Topic}";
		dirty = 1;
		break;
	case 'Delete this Topic':
		deleteMenuItem menuitem="{curTopic}";
		curTopic = "";
		dirty = 1;
		break;
	case 'Add this Topic':
		curTopic = "{sys%form:Topic}";
		// Fall through
	case 'Move this Topic':
		{MenuName}%query "select * from {MenuTable} where Topic = '{curTopic|TGE}'";
		existingRec = (db){MenuName};
		if ('{Submit}' == 'Move this Topic') {
			if ({#existingRec} == 0) {
				display '<center><span class="error">Topic Address "{curTopic}" ({existingRec:Name}) does not exist.</span></center>\n';
				break;
			}
			howTo = "{sys%form:howToMove}";
			toMenuItem = "{sys%form:moveTo}";
			{MenuName}%query "delete from {MenuTable} where Topic = '{curTopic|TGE}'";
			if ({{MenuName}%status}) {
				display '<center><span class="error">{{MenuName}%message} when deleting before the move (Error {{MenuName}%status})</span></center>\n';
				break;  // No more moving
			}
			foreach (existingRec) sys%form:{foreach:key} = "{foreach}";
		} else {
			if ({#existingRec}) {
				display '<center><span class="error">Topic Address "{curTopic}" ({existingRec:Name}) exists already.</span></center>\n';
				break;
			}
			howTo = "{sys%form:howToAdd}";
			toMenuItem = "{sys%form:addTo}";
		}
		switch ('{howTo}') {
		case 'under':
			param%insertMenuItem = (var)sys%form;
			param%insertMenuItem:Parent = "{toMenuItem}";
			insertMenuItem;
			dirty = 1;
			break;
		case 'after':
		case 'before':
			{MenuName}%query "select * from {MenuTable} where Topic = '{toMenuItem|TGE}'";
			toRec = (db){MenuName};
			clear recSet%;
			{MenuName}%query "select * from {MenuTable} where Parent = '{toRec:Parent|TGE}'";
			foreach ((db){MenuName}) {
				if ({#foreach} == 0) break;
				recSet%{foreach:Topic} = (var)foreach;
			}
			{MenuName}%query "delete from {MenuTable} where Parent = '{toRec:Parent|TGE}'";
//display "delete from {MenuTable} where Parent = '{toRec:Parent}'<br>\n";
			if ({{MenuName}%status}) {
				display '<center><span class="error">{{MenuName}%message} when deleting before menu re-organising (Error {{MenuName}%status})</span></center>\n';
				break;
			}
			foreach (class%recSet as recAddr) {
				if ('{recAddr}' == '{toMenuItem}' && '{howTo}' == 'before') {
					param%insertMenuItem = (var)sys%form;
					param%insertMenuItem:Parent = "{toRec:Parent}";
					insertMenuItem;
				}
	
				param%insertMenuItem = (var)recSet%{recAddr};
				insertMenuItem;
	
				if ('{recAddr}' == '{toMenuItem}' && '{howTo}' == 'after') {
					param%insertMenuItem = (var)sys%form;
					param%insertMenuItem:Parent = "{toRec:Parent}";
					insertMenuItem;
				}
			}
			dirty = 1;
			break;
		}
		break;
	}

	if ({dirty}) {
		submitVerb = "{Submit|replacere:\ .*}";
		if ({{MenuName}%status}) {
			display '<center><span class="error">ERROR {{MenuName}%status} when {submitVerb|verb:doing}: {{MenuName}%message}</span></center>\n';
			display "[{{MenuName}%query}]<br>\n";
		} else {
			switch ('{MenuType}') {
			case 'DB':
			case 'CSV':
				// No processing required
				break;
			case 'VB':
				// VB is default
			default:
				if ('{{PortalObjectName}%Phantom}') {
					{PortalObjectName}%savePhantomMenu;
				} else {
					{MenuName}%unload;
					if ({{MenuName}%status}) {
						display '<center><span class="error">ERROR {{MenuName}%status} when updating the menu: {{MenuName}%message}</span></center>\n';
						break;
					}
				}
				display '<center><span class="message">The Topic <font size="+2">{sys%form:Name|unescape} {=({curTopic})|if:"{curTopic}"}</font> has been {={Submit|replacere:\ .*}|verb:done}</span></center>\n';
				break;
			}
		
			// Need to refresh the MenuOptionTags as it might have changed
	
			if ('{Submit}' == 'Add this Topic') {
				{PortalObjectName}%pathPage PP="{{PortalObjectName}%Subpath}{sys%form:Page}";
				{PortalObjectName}%menuLoad Topic="{curTopic}";
			}

			// Clear all cache (might need to optimise if proven too slow)
			{PortalObjectName}%clearCache;
			{PortalObjectName}%menuRefresh;
		}
	}
}

MenuEditDisplay = "{sys%output:content}";
output buffercancel;
</script>
