<?php
include_once("bee/bee.php");
BEE_tagInitialise("xml_util.bs");
?><?php
function BEE_UserFunction_xml_filter()
{
	$BEE_f_startTime = gettimeofday();
	BEE_debugEnterFile("xml_util.bs");
	global $BEE_Var;
	global $BEE_f_contextParent;
	global $BEE_f_contextChild;
	global $BEE_f_nestedLevel;
	global $BEE_debug_active;
	global $BEE_debug_function_time;
	global $PHP_context;
	if (isset($BEE_f_nestedLevel)) $BEE_f_nestedLevel++;
	else $BEE_f_nestedLevel = 1;
	$BEE_f_functionName = "xml_filter";
	$BEE_f_linkName = $BEE_f_functionName;
	$BEE_context = $BEE_f_contextChild;
	$PHP_contextSaved = $PHP_context;
	$PHP_context = $BEE_context;
?><?php
BEE_debugEnterLine(7, $BEE_f_functionName, "function", $BEE_f_contextParent);
global $BEE_Var;
$BEE_paramName = "xml_filter";
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"] = BEE_tagVarValue("xml_filter", $BEE_f_contextParent);
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["whitelist"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["whitelist"] = BEE_tagVarValue("(array)open,complete", $BEE_f_contextParent);
?><?php
	$BEE_argContext =& BEE_VSC("arg", "function", $BEE_context);
	if (isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName]))
		$BEE_argContext = $BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName];
	foreach ($BEE_argContext as $BEE_key => $BEE_val)
	{
		if ($BEE_key == "function") continue;
		$BEE_argVar =& BEE_VSC("arg", $BEE_key, $BEE_context);
		$BEE_argValue = BEE_tagTypedGet($BEE_val, $BEE_f_contextParent);
		if (is_array($BEE_argValue))
		{
			$BEE_argVar = $BEE_argValue;
		} else
		{
			$BEE_argVar[""] = $BEE_argValue;
			if ($BEE_key == BEE_THISFUNCTION_ATTR_NAME) $BEE_f_linkName = $BEE_argValue;
		}
	}
	if (!isset($BEE_argContext["arg"]))
	{
		$BEE_argArg = "";
		if (strlen($BEE_argContext["new"])) $BEE_argArg = "new";
		else if (strlen($BEE_argContext["thisfunction"])) $BEE_argArg = $BEE_argContext["thisfunction"];
		else if (strlen($BEE_argContext["function"])) $BEE_argArg = $BEE_argContext["function"];
		if (strlen($BEE_argArg))
		{
			$BEE_argArgContext =& BEE_VSC("arg", strtolower($BEE_argArg), $BEE_context);
			BEE_VSC("arg", "arg", $BEE_context);
			$BEE_Var[$BEE_context]["arg"]["arg"] =& $BEE_argArgContext;
		}
	}
	if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0)
		BEE_debugPrint(sprintf("%s[%s entered]
", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName));
	$BEE_f_thisName = $BEE_argContext[BEE_THIS_ATTR_NAME];
	if ($BEE_f_thisName != "")
		$BEE_Var[$BEE_f_contextChild][BEE_THIS_ATTR_NAME] =& $BEE_Var[$BEE_f_contextParent][$BEE_f_thisName];
?><?php
/***** function *****/
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(8, $BEE_f_functionName, "var node", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("node", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{arg%node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(9, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{arg%function:node|isset} == 0", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(9, $BEE_f_functionName, "var node", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("node", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{this%root}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(11, $BEE_f_functionName, "{this%function:xml_filtersubtree}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_filtersubtree", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_filtersubtree}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"] = BEE_tagVarValue("{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_filtersubtree", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(12, $BEE_f_functionName, "{this%function:xml_reset}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_reset", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_reset}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_reset", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
}
?><?php
function BEE_UserFunction_xml_filtersubtree()
{
	$BEE_f_startTime = gettimeofday();
	BEE_debugEnterFile("xml_util.bs");
	global $BEE_Var;
	global $BEE_f_contextParent;
	global $BEE_f_contextChild;
	global $BEE_f_nestedLevel;
	global $BEE_debug_active;
	global $BEE_debug_function_time;
	global $PHP_context;
	if (isset($BEE_f_nestedLevel)) $BEE_f_nestedLevel++;
	else $BEE_f_nestedLevel = 1;
	$BEE_f_functionName = "xml_filtersubtree";
	$BEE_f_linkName = $BEE_f_functionName;
	$BEE_context = $BEE_f_contextChild;
	$PHP_contextSaved = $PHP_context;
	$PHP_context = $BEE_context;
?><?php
BEE_debugEnterLine(18, $BEE_f_functionName, "function", $BEE_f_contextParent);
global $BEE_Var;
$BEE_paramName = "xml_filtersubtree";
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"] = BEE_tagVarValue("xml_filtersubtree", $BEE_f_contextParent);
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["whitelist"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["whitelist"] = BEE_tagVarValue("(array)open,complete", $BEE_f_contextParent);
?><?php
	$BEE_argContext =& BEE_VSC("arg", "function", $BEE_context);
	if (isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName]))
		$BEE_argContext = $BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName];
	foreach ($BEE_argContext as $BEE_key => $BEE_val)
	{
		if ($BEE_key == "function") continue;
		$BEE_argVar =& BEE_VSC("arg", $BEE_key, $BEE_context);
		$BEE_argValue = BEE_tagTypedGet($BEE_val, $BEE_f_contextParent);
		if (is_array($BEE_argValue))
		{
			$BEE_argVar = $BEE_argValue;
		} else
		{
			$BEE_argVar[""] = $BEE_argValue;
			if ($BEE_key == BEE_THISFUNCTION_ATTR_NAME) $BEE_f_linkName = $BEE_argValue;
		}
	}
	if (!isset($BEE_argContext["arg"]))
	{
		$BEE_argArg = "";
		if (strlen($BEE_argContext["new"])) $BEE_argArg = "new";
		else if (strlen($BEE_argContext["thisfunction"])) $BEE_argArg = $BEE_argContext["thisfunction"];
		else if (strlen($BEE_argContext["function"])) $BEE_argArg = $BEE_argContext["function"];
		if (strlen($BEE_argArg))
		{
			$BEE_argArgContext =& BEE_VSC("arg", strtolower($BEE_argArg), $BEE_context);
			BEE_VSC("arg", "arg", $BEE_context);
			$BEE_Var[$BEE_context]["arg"]["arg"] =& $BEE_argArgContext;
		}
	}
	if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0)
		BEE_debugPrint(sprintf("%s[%s entered]
", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName));
	$BEE_f_thisName = $BEE_argContext[BEE_THIS_ATTR_NAME];
	if ($BEE_f_thisName != "")
		$BEE_Var[$BEE_f_contextChild][BEE_THIS_ATTR_NAME] =& $BEE_Var[$BEE_f_contextParent][$BEE_f_thisName];
?><?php
/***** function *****/
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(19, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{arg%function:node|isset} == 0", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(19, $BEE_f_functionName, "return", $BEE_context);
global $BEE_Var;
$BEE_paramName = "return";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["status"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["status"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["message"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["message"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(21, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("'{arg%whitelist|search:{this%xml_{arg%node}:type}' == ''", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(23, $BEE_f_functionName, "{this%function:xml_clear}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_clear", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_clear}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"] = BEE_tagVarValue("{arg%node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_clear", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
} else {
?><?php
BEE_debugEnterLine(24, $BEE_f_functionName, "else", $BEE_context);
global $BEE_Var;
$BEE_paramName = "else";
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(26, $BEE_f_functionName, "{this%function:tree_children}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("tree_children", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:tree_children}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"] = BEE_tagVarValue("{arg%node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("tree_children", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(27, $BEE_f_functionName, "foreach", $BEE_context);
global $BEE_Var;
$BEE_paramName = "foreach";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"] = BEE_tagVarValue("result%tree_children", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"] = BEE_tagVarValue("foreach", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"] = BEE_tagVarValue("1000", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** foreach *****/
global $BEE_s_stackPointer;
global $BEE_s_break;
if (isset($BEE_s_stackPointer)) $BEE_s_stackPointer++;
else $BEE_s_stackPointer = 0;
if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp++;
else $BEE_loopReturnComp = 1;
BEE_tagLibForeach_beforeLoop($BEE_context);
while (true)
{
	BEE_tagLibForeach_inLoop($BEE_context);
	if ($BEE_s_break[$BEE_s_stackPointer])
	{
		$BEE_s_stackPointer--;
		if ($BEE_s_stackPointer < 0) unset($BEE_s_stackPointer);
		if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp--;
		else $BEE_loopReturnComp = 0;
		break;
	}
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(27, $BEE_f_functionName, "{this%function:xml_filtersubtree}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_filtersubtree", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_filtersubtree}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"] = BEE_tagVarValue("{foreach}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_filtersubtree", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
}
?><?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
}
?>
<?php
BEE_tagFinalise();
?>
